#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "cdi.h"
#include "tinecdi.h"
#include "cdiSimulateLib.h"

#define BUSPLUG_NAME "SIMULATE"
char gBusPlugName[64] = BUSPLUG_NAME;
int cdiInitSimulate(void)
{
  int cc = 0;

  /* any filter function for data on the bus ? */
  if ((cc=cdiRegisterBusFilter(gBusPlugName,filterSimulation)) != 0 ) goto err;
  /* how to get things started:*/
  if ((cc=cdiRegisterBusInitialization(gBusPlugName,initSimulation)) != 0 ) goto err;
  /* where the action is: */
  if ((cc=cdiRegisterBusHandler(gBusPlugName,simulationHandler)) != 0 ) goto err;
  /* how to clean things up when we're unloaded */
  if ((cc=cdiRegisterBusCleanup(gBusPlugName,exitSimulation)) != 0 ) goto err;
  /* any diagnostic scanning functions ?  */
  if ((cc=cdiRegisterBusScanner(gBusPlugName,scanSimulationBus)) != 0 ) goto err;
err:
  if (cc)
  {
    cdilog("%s : failure in bus registration SEDPC",erlst[cc]);
  }
  return cc;
}
void fixBusPlugName(void)
{
  char *ptr = getenv("CDI_SIMULATE_PLUG");
  if (ptr != NULL && strlen(ptr) > 0)
  {
    strncpy(gBusPlugName, ptr, 16);
    gBusPlugName[16] = 0;
  }
}
#if defined(WIN32)
BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      fixBusPlugName();
      cdiInitSimulate();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      break;
  }
  return (TRUE);
}
#elif defined(UNIX)
__attribute__((constructor)) void cdiSedacMain(void)
{
  fixBusPlugName();
  cdiInitSimulate();
  return;
}
#endif
